hdu 1300 (dp)

来源:互联网 发布:网络团队招人广告词 编辑:程序博客网 时间:2024/05/21 20:21

Pearls

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 1225    Accepted Submission(s): 550


Problem Description
In Pearlania everybody is fond of pearls. One company, called The Royal Pearl, produces a lot of jewelry with pearls in it. The Royal Pearl has its name because it delivers to the royal family of Pearlania. But it also produces bracelets and necklaces for ordinary people. Of course the quality of the pearls for these people is much lower then the quality of pearls for the royal family. In Pearlania pearls are separated into 100 different quality classes. A quality class is identified by the price for one single pearl in that quality class. This price is unique for that quality class and the price is always higher then the price for a pearl in a lower quality class.

Every month the stock manager of The Royal Pearl prepares a list with the number of pearls needed in each quality class. The pearls are bought on the local pearl market. Each quality class has its own price per pearl, but for every complete deal in a certain quality class one has to pay an extra amount of money equal to ten pearls in that class. This is to prevent tourists from buying just one pearl.

Also The Royal Pearl is suffering from the slow-down of the global economy. Therefore the company needs to be more efficient. The CFO (chief financial officer) has discovered that he can sometimes save money by buying pearls in a higher quality class than is actually needed. No customer will blame The Royal Pearl for putting better pearls in the bracelets, as long as the prices remain the same.

For example 5 pearls are needed in the 10 Euro category and 100 pearls are needed in the 20 Euro category. That will normally cost: (5+10)*10 + (100+10)*20 = 2350 Euro.

Buying all 105 pearls in the 20 Euro category only costs: (5+100+10)*20 = 2300 Euro.

The problem is that it requires a lot of computing work before the CFO knows how many pearls can best be bought in a higher quality class. You are asked to help The Royal Pearl with a computer program.

Given a list with the number of pearls and the price per pearl in different quality classes, give the lowest possible price needed to buy everything on the list. Pearls can be bought in the requested, or in a higher quality class, but not in a lower one.
 

Input
The first line of the input contains the number of test cases. Each test case starts with a line containing the number of categories c (1 <= c <= 100). Then, c lines follow, each with two numbers ai and pi. The first of these numbers is the number of pearls ai needed in a class (1 <= ai <= 1000). The second number is the price per pearl pi in that class (1 <= pi <= 1000). The qualities of the classes (and so the prices) are given in ascending order. All numbers in the input are integers.
 

Output
For each test case a single line containing a single number: the lowest possible price needed to buy everything on the list.
 

Sample Input
22100 1100 231 101 11100 12
 

Sample Output
3301344
 

Source
Northwestern Europe 2002
 

Recommend
Eddy
 
可以看出每种物品一定是在同种价格下一次买完的,并且如果我要以当前价格购买时,一定也会把前面所有积累的还没买的都在这种价格下买掉。dp[i][j]表示买完前i种物品,还剩余j个物品的最小花费,然后用从前往后推的方式,再加优先队列和一点剪枝,用这个bfs的方法也被我把这题水过了。这个方法理论上是不会超时的,因为可到达的状态实际上非常少。不过这题的更好方法是,dp[i]表示把前i种物品买完,dp[i]=min{dp[j]+value}(0<=j<i, value为第j+1类珠宝到第i类全部以i类买入的价值; );然后我们可以用一个数组记录一下0-i的花费。O(n^2)复杂度,还是好很多的。
贴上第一种做法的代码:
#include <iostream>#include <cstring>#include <cstdio>#include <string>#include <algorithm>#include <map>#include <vector>#include <queue>#include <set>#include <cmath>using namespace std;typedef long long LL;typedef pair<int,int> PP;typedef pair<int,PP> P;const int maxn = 100 + 5;const int INF = 1000000000;int num[maxn],p[maxn];priority_queue<P> Q;map<PP,int> M;int bfs(int n){    while(!Q.empty()){        P s = Q.top();Q.pop();        int price = -s.first;        PP ss = s.second;        int pos = ss.first;        int sum = ss.second;        M[PP(pos,sum)] = 1;        if(pos == n && sum == 0) return price;        if(pos < n){            if(M[PP(pos+1,0)] == 0)                Q.push(P(-(price+(10+sum+num[pos+1])*p[pos+1]),PP(pos+1,0)));            if(M[PP(pos+1,sum+num[pos+1])] == 0)                Q.push(P(-price,PP(pos+1,sum+num[pos+1])));        }    }}int main(){    int t;    scanf("%d",&t);    while(t--){        int n;        scanf("%d",&n);        for(int i = 1;i <= n;i++){            scanf("%d%d",&num[i],&p[i]);        }        M.clear();        while(!Q.empty()) Q.pop();        Q.push(P(-(num[1]+10)*p[1],PP(1,0)));        Q.push(P(0,PP(1,num[1])));        int ans = bfs(n);        printf("%d\n",ans);    }    return 0;}